/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreValuelist.TCoreValuelistPath;
import de.ship.db.tables.records.TCoreValuetypeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreValuetype extends TableImpl<TCoreValuetypeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_valuetype</code>
     */
    public static final TCoreValuetype T_CORE_VALUETYPE = new TCoreValuetype();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreValuetypeRecord> getRecordType() {
        return TCoreValuetypeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_valuetype.pk</code>.
     */
    public final TableField<TCoreValuetypeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_valuetype.pattern</code>. list of
     * values
     */
    public final TableField<TCoreValuetypeRecord, String> PATTERN = createField(DSL.name("pattern"), SQLDataType.CLOB.nullable(false), this, "list of values");

    /**
     * The column <code>common_dd.t_core_valuetype.lastchange</code>.
     */
    public final TableField<TCoreValuetypeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCoreValuetype(Name alias, Table<TCoreValuetypeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreValuetype(Name alias, Table<TCoreValuetypeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_valuetype</code> table reference
     */
    public TCoreValuetype(String alias) {
        this(DSL.name(alias), T_CORE_VALUETYPE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_valuetype</code> table reference
     */
    public TCoreValuetype(Name alias) {
        this(alias, T_CORE_VALUETYPE);
    }

    /**
     * Create a <code>common_dd.t_core_valuetype</code> table reference
     */
    public TCoreValuetype() {
        this(DSL.name("t_core_valuetype"), null);
    }

    public <O extends Record> TCoreValuetype(Table<O> path, ForeignKey<O, TCoreValuetypeRecord> childPath, InverseForeignKey<O, TCoreValuetypeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_VALUETYPE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreValuetypePath extends TCoreValuetype implements Path<TCoreValuetypeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreValuetypePath(Table<O> path, ForeignKey<O, TCoreValuetypeRecord> childPath, InverseForeignKey<O, TCoreValuetypeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreValuetypePath(Name alias, Table<TCoreValuetypeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreValuetypePath as(String alias) {
            return new TCoreValuetypePath(DSL.name(alias), this);
        }

        @Override
        public TCoreValuetypePath as(Name alias) {
            return new TCoreValuetypePath(alias, this);
        }

        @Override
        public TCoreValuetypePath as(Table<?> alias) {
            return new TCoreValuetypePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreValuetypeRecord, Integer> getIdentity() {
        return (Identity<TCoreValuetypeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreValuetypeRecord> getPrimaryKey() {
        return Keys.PK_CORE_VALUETYPE;
    }

    @Override
    public List<UniqueKey<TCoreValuetypeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_VALUETYPE);
    }

    private transient TCoreValuelistPath _tCoreValuelist;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_valuelist</code> table
     */
    public TCoreValuelistPath tCoreValuelist() {
        if (_tCoreValuelist == null)
            _tCoreValuelist = new TCoreValuelistPath(this, null, Keys.T_CORE_VALUELIST__FK_CORE_VALUELIST_VALUETYPE.getInverseKey());

        return _tCoreValuelist;
    }

    @Override
    public TCoreValuetype as(String alias) {
        return new TCoreValuetype(DSL.name(alias), this);
    }

    @Override
    public TCoreValuetype as(Name alias) {
        return new TCoreValuetype(alias, this);
    }

    @Override
    public TCoreValuetype as(Table<?> alias) {
        return new TCoreValuetype(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValuetype rename(String name) {
        return new TCoreValuetype(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValuetype rename(Name name) {
        return new TCoreValuetype(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValuetype rename(Table<?> name) {
        return new TCoreValuetype(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValuetype where(Condition condition) {
        return new TCoreValuetype(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValuetype where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValuetype where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValuetype where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValuetype where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValuetype where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValuetype where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValuetype where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValuetype whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValuetype whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
